{****************************************************************************
 * SoundLib 2 alpha Version - copyright (c) 1997-2001 by Stefan Goehler     *
 * Any bug reports and suggestions are welcome                              *
 * Copyright agreement in soundlib.txt - illegal copy without this file!    *
 * Complete package and new version always available here:                  *
 * http://sourcenet.home.pages.de                                           *
 ****************************************************************************}
{$IFDEF FPC}
{$A+,B-,F+,G+,N+,E-,P+,Q-,R-,T-,V+,X+,I+}
{$ASMMODE INTEL}
{$ELSE}
{$A+,B-,F+,G+,N+,E-,P+,Q-,R-,T-,V+,X+}
{$ENDIF}
unit snd_cnv;

interface

{$IFNDEF FPC}
uses newfrontier;

type
  pointr = pointer48;

{$ELSE}
type
  pointr = pointer;
{$ENDIF}

{procedure sat32(data : pointr;samples : longint);}
procedure aud_us8_to_s16(source,dest : pointr;samples : longint);
procedure aud_s8_to_s16(source,dest : pointr;samples : longint);
procedure aud_us16_to_s16(source,dest : pointr;samples : longint);

procedure aud_s32_to_ds8(source1,source2,dest : pointr;samples : longint);
procedure aud_s32_to_dus8(source1,source2,dest : pointr;samples : longint);
procedure aud_s32_to_ds16(source1,source2,dest : pointr;samples : longint);
procedure aud_s32_to_dus16(source1,source2,dest : pointr;samples : longint);

procedure aud_s32_to_s16(source,dest : pointr;samples : longint);
procedure aud_s32_to_sm16(source,dest : pointr;samples : longint);
procedure aud_s32_to_us16(source,dest : pointr;samples : longint);
procedure aud_s32_to_usm16(source,dest : pointr;samples : longint);
procedure aud_s32_to_s8(source,dest : pointr;samples : longint);
procedure aud_s32_to_sm8(source,dest : pointr;samples : longint);
procedure aud_s32_to_us8(source,dest : pointr;samples : longint);
procedure aud_s32_to_usm8(source,dest : pointr;samples : longint);

{procedure delta8_to_16(source,dest : pointr;samples : longint);
procedure delta16_to_16(source,dest : pointr;samples : longint);}

implementation

{$IFNDEF FPC}
{$L snd_cnv}
procedure sat32;external;
procedure aud_us8_to_s16;external;
procedure aud_s8_to_s16;external;
procedure aud_us16_to_s16;external;

procedure aud_s32_to_ds8;external;
procedure aud_s32_to_dus8;external;
procedure aud_s32_to_ds16;external;
procedure aud_s32_to_dus16;external;

procedure aud_s32_to_s16;external;
procedure aud_s32_to_sm16;external;
procedure aud_s32_to_us16;external;
procedure aud_s32_to_usm16;external;
procedure aud_s32_to_s8;external;
procedure aud_s32_to_sm8;external;
procedure aud_s32_to_us8;external;
procedure aud_s32_to_usm8;external;

procedure delta8_to_16;external;
procedure delta16_to_16;external;
{$ELSE}

procedure aud_us8_to_s16(source,dest : pointer;samples : longint);assembler;
asm
  mov   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_us8

  mov   esi,dest
@lp_us8:
  mov   al,0
  mov   ah,ds:[edi]
  sub   ax,32768
  mov   ds:[esi],ax
  add   esi,2
  inc   edi
  dec   ecx
  jnz   @lp_us8
@end_us8:
end;

procedure aud_s8_to_s16(source,dest : pointer;samples : longint);assembler;
asm
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s8

  mov   edi,source
  mov   esi,dest

  mov   al,0
@lp_s8:
  mov   ah,ds:[edi]
  mov   ds:[esi],ax
  add   esi,2
  inc   edi
  dec   ecx
  jnz   @lp_s8
@end_s8:
end;

procedure aud_us16_to_s16(source,dest : pointer;samples : longint);assembler;
asm
  mov   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_us16

  mov   esi,dest
@lp_us16:
  mov   al,0
  mov   ax,ds:[edi]
  sub   ax,32768
  mov   ds:[esi],ax
  add   esi,2
  add   edi,2
  dec   ecx
  jnz   @lp_us16
@end_us16:
end;


procedure aud_s32_to_ds8(source1,source2,dest : pointer;samples : longint);assembler;
asm
  mov   edi,source1
  mov   edx,source2
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32ds8

  mov   esi,dest
@lp_s32ds8:
  mov   eax,ds:[edi]
  mov   ebx,ds:[edx+8]
  sub   eax,ebx
  cmp   eax,1FFFFFFFh
  jng   @na_s32ds8_1
    mov   eax,1FFFFFFFh
    jmp   @out_s32ds8_1
  @na_s32ds8_1:
  cmp   eax,0E0000001h
  jnl   @out_s32ds8_1
    mov   eax,0E0000001h
@out_s32ds8_1:
  add   eax,eax
  shr   eax,24
  mov   ds:[esi],al

  mov   eax,ds:[edi+4]
  add   eax,ebx
  cmp   eax,1FFFFFFFh
  jng   @na_s32ds8_2
    mov   eax,1FFFFFFFh
    jmp   @out_s32ds8_2
  @na_s32ds8_2:
  cmp   eax,0E0000001h
  jnl   @out_s32ds8_2
    mov   eax,0E0000001h
@out_s32ds8_2:
  add   eax,eax
  shr   eax,24
  mov   ds:[esi+1],al

  add   edi,12
  add   edx,12
  add   esi,2
  dec   ecx
  jnz   @lp_s32ds8
@end_s32ds8:
end;

procedure aud_s32_to_dus8(source1,source2,dest : pointer;samples : longint);assembler;
asm
  mov   edi,source1
  mov   edx,source2
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32du8

  mov   esi,dest
@lp_s32du8:
  mov   eax,ds:[edi]
  mov   ebx,ds:[edx+8]
  sub   eax,ebx
  cmp   eax,1FFFFFFFh
  jng   @na_s32du8_1
    mov   eax,1FFFFFFFh
    jmp   @out_s32du8_1
  @na_s32du8_1:
  cmp   eax,0E0000001h
  jnl   @out_s32du8_1
    mov   eax,0E0000001h
@out_s32du8_1:
  add   eax,eax
  shr   eax,24
  add   al,128
  mov   ds:[esi],al

  mov   eax,ds:[edi+4]
  add   eax,ebx
  cmp   eax,1FFFFFFFh
  jng   @na_s32du8_2
    mov   eax,1FFFFFFFh
    jmp   @out_s32du8_2
  @na_s32du8_2:
  cmp   eax,0E0000001h
  jnl   @out_s32du8_2
    mov   eax,0E0000001h
@out_s32du8_2:
  add   eax,eax
  shr   eax,24
  add   al,128
  mov   ds:[esi+1],al

  add   edi,12
  add   edx,12
  add   esi,2
  dec   ecx
  jnz   @lp_s32du8
@end_s32du8:
end;

procedure aud_s32_to_ds16(source1,source2,dest : pointer;samples : longint);assembler;
asm
  mov   edi,source1
  mov   edx,source2
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32ds16

  mov   esi,dest
@lp_s32ds16:
  mov   eax,ds:[edi]
  mov   ebx,ds:[edx+8]
  sub   eax,ebx
  cmp   eax,1FFFFFFFh
  jng   @na_s32d16_1
    mov   eax,1FFFFFFFh
    jmp   @out_s32d16_1
  @na_s32d16_1:
  cmp   eax,0E0000001h
  jnl   @out_s32d16_1
    mov   eax,0E0000001h
@out_s32d16_1:
  add   eax,eax
  shr   eax,16
  mov   ds:[esi],ax

  mov   eax,ds:[edi+4]
  add   eax,ebx
  cmp   eax,1FFFFFFFh
  jng   @na_s32d16_2
    mov   eax,1FFFFFFFh
    jmp   @out_s32d16_2
  @na_s32d16_2:
  cmp   eax,0E0000001h
  jnl   @out_s32d16_2
    mov   eax,0E0000001h
@out_s32d16_2:
  add   eax,eax
  shr   eax,16
  mov   ds:[esi+2],ax

  add   edi,12
  add   edx,12
  add   esi,4
  dec   ecx
  jnz   @lp_s32ds16
@end_s32ds16:
end;

procedure aud_s32_to_dus16(source1,source2,dest : pointer;samples : longint);assembler;
asm
  mov   edi,source1
  mov   edx,source2
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32du16

  mov   esi,dest
@lp_s32du16:
  mov   eax,ds:[edi]
  mov   ebx,ds:[edx+8]
  sub   eax,ebx
  cmp   eax,1FFFFFFFh
  jng   @na_s32du16_1
    mov   eax,1FFFFFFFh
    jmp   @out_s32du16_1
  @na_s32du16_1:
  cmp   eax,0E0000001h
  jnl   @out_s32du16_1
    mov   eax,0E0000001h
@out_s32du16_1:
  add   eax,eax
  shr   eax,16
  add   ax,32768
  mov   ds:[esi],ax

  mov   eax,ds:[edi+4]
  add   eax,ebx
  cmp   eax,1FFFFFFFh
  jng   @na_s32du16_2
    mov   eax,1FFFFFFFh
    jmp   @out_s32du16_2
  @na_s32du16_2:
  cmp   eax,0E0000001h
  jnl   @out_s32du16_2
    mov   eax,0E0000001h
@out_s32du16_2:
  add   eax,eax
  shr   eax,16
  add   ax,32768
  mov   ds:[esi+2],ax

  add   edi,12
  add   edx,12
  add   esi,4
  dec   ecx
  jnz   @lp_s32du16
@end_s32du16:
end;


procedure aud_s32_to_s16(source,dest : pointer;samples : longint);assembler;
asm
  mov   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s3216

  mov   esi,dest
@lp_s3216:
  mov   eax,ds:[edi]

  cmp   eax,1FFFFFFFh
  jng   @na_s3216
    mov   eax,1FFFFFFFh
    jmp   @out_s3216
  @na_s3216:
  cmp   eax,0E0000001h
  jnl   @out_s3216
    mov   eax,0E0000001h
@out_s3216:
  add   eax,eax

  shr   eax,16
  mov   ds:[esi],ax
  add   edi,4
  add   esi,2
  dec   ecx
  jnz   @lp_s3216
@end_s3216:
end;

procedure aud_s32_to_sm16(source,dest : pointer;samples : longint);assembler;
asm
  mov   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32m16

  mov   esi,dest
@lp_s32m16:
  mov   eax,ds:[edi]

  cmp   eax,1FFFFFFFh
  jng   @na_s32m16_1
    mov   eax,1FFFFFFFh
    jmp   @out_s32m16_1
  @na_s32m16_1:
  cmp   eax,0E0000001h
  jnl   @out_s32m16_1
    mov   eax,0E0000001h
@out_s32m16_1:

  mov ebx,ds:[edi+4]

  cmp   ebx,1FFFFFFFh
  jng   @na_s32m16_2
    mov   ebx,1FFFFFFFh
    jmp   @out_s32m16_2
  @na_s32m16_2:
  cmp   ebx,0E0000001h
  jnl   @out_s32m16_2
    mov   ebx,0E0000001h
@out_s32m16_2:

  add   eax,ebx
  shr   eax,16
  mov   ds:[esi],ax
  add   edi,8
  add   esi,2
  dec   ecx
  jnz   @lp_s32m16
@end_s32m16:
end;

procedure aud_s32_to_us16(source,dest : pointer;samples : longint);assembler;
asm
  mov   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32u16

  mov   esi,dest
@lp_s32u16:
  mov   eax,ds:[edi]

  cmp   eax,1FFFFFFFh
  jng   @na_us3216
    mov   eax,1FFFFFFFh
    jmp   @out_us3216
  @na_us3216:
  cmp   eax,0E0000001h
  jnl   @out_us3216
    mov   eax,0E0000001h
@out_us3216:
  add   eax,eax
  shr   eax,16

  add   ax,32768
  mov   ds:[esi],ax
  add   edi,4
  add   esi,2
  dec   ecx
  jnz   @lp_s32u16
@end_s32u16:
end;

procedure aud_s32_to_usm16(source,dest : pointer;samples : longint);assembler;
asm
  mov   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32um16

  mov   esi,dest
  xor   eax,eax
  xor   ebx,ebx
@lp_s32um16:
  mov   eax,ds:[edi]

  cmp   eax,1FFFFFFFh
  jng   @na_us32m16_1
    mov   eax,1FFFFFFFh
    jmp   @out_us32m16_1
  @na_us32m16_1:
  cmp   eax,0E0000001h
  jnl   @out_us32m16_1
    mov   eax,0E0000001h
@out_us32m16_1:

  mov ebx,ds:[edi+4]

  cmp   ebx,1FFFFFFFh
  jng   @na_us32m16_2
    mov   ebx,1FFFFFFFh
    jmp   @out_us32m16_2
  @na_us32m16_2:
  cmp   ebx,0E0000001h
  jnl   @out_us32m16_2
    mov   ebx,0E0000001h
@out_us32m16_2:

  add   eax,ebx
  shr   eax,16

  mov   ds:[esi],ax
  add   edi,8
  add   esi,2
  dec   ecx
  jnz   @lp_s32um16
@end_s32um16:
end;

procedure aud_s32_to_s8(source,dest : pointer;samples : longint);assembler;
asm
  mov   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32s8

  mov   esi,dest
@lp_s32s8:
  mov   eax,ds:[edi]

  cmp   eax,1FFFFFFFh
  jng   @na_s328
    mov   eax,1FFFFFFFh
    jmp   @out_s328
  @na_s328:
  cmp   eax,0E0000001h
  jnl   @out_s328
    mov   eax,0E0000001h
@out_s328:
  add   eax,eax

  shr   eax,24

  mov   ds:[esi],al
  add   edi,4
  inc   esi
  dec   ecx
  jnz   @lp_s32s8
@end_s32s8:
end;

procedure aud_s32_to_sm8(source,dest : pointer;samples : longint);assembler;
asm
  mov   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32m8

  mov   esi,dest
@lp_s32m8:
  mov   eax,ds:[edi]

  cmp   eax,1FFFFFFFh
  jng   @na_s32m8_1
    mov   eax,1FFFFFFFh
    jmp   @out_s32m8_1
  @na_s32m8_1:
  cmp   eax,0E0000001h
  jnl   @out_s32m8_1
    mov   eax,0E0000001h
@out_s32m8_1:

  mov ebx,ds:[edi+4]

  cmp   ebx,1FFFFFFFh
  jng   @na_s32m8_2
    mov   ebx,1FFFFFFFh
    jmp   @out_s32m8_2
  @na_s32m8_2:
  cmp   ebx,0E0000001h
  jnl   @out_s32m8_2
    mov   ebx,0E0000001h
@out_s32m8_2:

  add   eax,ebx
  shr   eax,24
  mov   ds:[esi],al
  add   edi,8
  inc   esi
  dec   ecx
  jnz   @lp_s32m8
@end_s32m8:
end;

procedure aud_s32_to_us8(source,dest : pointer;samples : longint);assembler;
asm
  mov   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32u8

  mov   esi,dest
@lp_s32u8:
  mov   eax,ds:[edi]

  cmp   eax,1FFFFFFFh
  jng   @na_us328
    mov   eax,1FFFFFFFh
    jmp   @out_us328
  @na_us328:
  cmp   eax,0E0000001h
  jnl   @out_us328
    mov   eax,0E0000001h
@out_us328:
  add   eax,eax
  shr   eax,24

  add   al,80h
  mov   ds:[esi],al
  add   edi,4
  inc   esi
  dec   ecx
  jnz   @lp_s32u8
@end_s32u8:
end;

procedure aud_s32_to_usm8(source,dest : pointer;samples : longint);assembler;
asm
  mov   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32um8

  mov   esi,dest
  xor   eax,eax
  xor   ebx,ebx
@lp_s32um8:
  mov   eax,ds:[edi]

  cmp   eax,1FFFFFFFh
  jng   @na_us32m8_1
    mov   eax,1FFFFFFFh
    jmp   @out_us32m8_1
  @na_us32m8_1:
  cmp   eax,0E0000001h
  jnl   @out_us32m8_1
    mov   eax,0E0000001h
@out_us32m8_1:

  mov ebx,ds:[edi+4]

  cmp   ebx,1FFFFFFFh
  jng   @na_us32m8_2
    mov   ebx,1FFFFFFFh
    jmp   @out_us32m8_2
  @na_us32m8_2:
  cmp   ebx,0E0000001h
  jnl   @out_us32m8_2
    mov   ebx,0E0000001h
@out_us32m8_2:

  add   eax,ebx
  shr   eax,24
  add   al,80h

  mov   ds:[esi],al
  add   edi,8
  inc   esi
  dec   ecx
  jnz   @lp_s32um8
@end_s32um8:
end;
{$ENDIF}

begin
end.
